////////////////////////////////////////////////////////////////////////////////
//	Filename :		Chapter2.cpp
//	Description :	Main file for Chapter 2.
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Included headers
////////////////////////////////////////////////////////////////////////////////
#include	"Chapter2.h"


////////////////////////////////////////////////////////////////////////////////
//	Definitions
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Global variables
////////////////////////////////////////////////////////////////////////////////
char	szClassName [] = "Chapter2";
char	szWinName [] = "Chapter2";
	

////////////////////////////////////////////////////////////////////////////////
//	Structures
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Classes
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Functions
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//	Function name :	WinMain ()
//	Description :	Start up of program.
////////////////////////////////////////////////////////////////////////////////
int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR Cmd, int Show)

{

	MSG				msg;
	HWND			hWnd;
	WNDCLASSEX		wcl;

	bool			Running = true;

	ZeroMemory (&wcl, sizeof (WNDCLASSEX));
	wcl.cbSize			=	sizeof (WNDCLASSEX);
	wcl.hInstance		=	hInst;
	wcl.lpszClassName	=	szClassName;
	wcl.lpfnWndProc		=	WndProc;
	wcl.style			=	0;

	wcl.lpszMenuName	=	NULL;
	wcl.cbClsExtra		=	NULL;
	wcl.cbWndExtra		=	NULL;

	wcl.hIcon	=	LoadIcon (NULL, IDI_APPLICATION);
	wcl.hIconSm	=	LoadIcon (NULL, IDI_APPLICATION);
	wcl.hCursor	=	LoadCursor (NULL, IDC_ARROW);
	wcl.hbrBackground	=	(HBRUSH) GetStockObject(BLACK_BRUSH);

	if (!RegisterClassEx(&wcl)) 
		
	{

		ErrorHandling.ProcessError (ERROR_REGISTER_CLASS);
		
		return (-1);
		
	}

	hWnd = CreateWindow (szClassName, szWinName, WS_OVERLAPPEDWINDOW,0 , 0, 640, 480, 
						 HWND_DESKTOP, NULL, hInst, NULL);

	ShowWindow(hWnd, Show);

	while (Running)

	{

        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))

        {
        
			if (msg.message == WM_QUIT)
            
			{
			
				Running = false;
			
			}
			
			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

		else 
		
		{

		}

	}

	return 0;
}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	WndProc ()
//	Description :	Handles messages.
////////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc (HWND hWnd,UINT msg , WPARAM wParam, LPARAM lParam)

{

	switch (msg)
	
	{

	case	WM_DESTROY:

		PostQuitMessage(0);
		
		return 0;


	default:

		return DefWindowProc (hWnd, msg, wParam, lParam);
		break;

	}
	
	return 0;

}
